/* <nage01.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library e01 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2146 (Feb 1998).
 * Mark 6 revised. IER-3028 (July 2000).
 */
#ifndef NAGE01
#define NAGE01
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* begin proto */

  extern NAG_DLL_EXPIMP void NAG_CALL e01aec(Integer m, double xmin, double xmax, const double x[], const double y[], const Integer p[], Integer itmin, Integer itmax, double a[], double perf[], Integer *num_iter, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01bac(Integer m, double x[], double y[],
                                             Nag_Spline *spline, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01bec(Integer n, double x[], double f[], double d[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01bfc(Integer n, double x[], double f[], double d[], Integer m, double px[],
                                             double pf[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01bgc(Integer n, double x[], double f[], double d[],
                                             Integer m, double px[], double pf[], double pd[],
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01bhc(Integer n, double x[], double f[], double d[],
                                             double a, double b, double *integral, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01dac(Integer mx, Integer my, double x[], double y[],
                                             double f[],Nag_2dSpline *spline, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e01rac(Integer n, const double x[], const double f[], Integer *m, double a[], double u[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e01rbc(Integer m, const double a[], const double u[], double x, double *f, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01sac(Nag_2d_Scat_Method method, Integer m, double x[], double y[],
                                             double f[], Nag_Scat_Struct *comm, Nag_E01_Opt *optional,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01sbc(Nag_Scat_Struct *comm, Integer n, double px[], double py[],
                                             double pf[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e01sgc(Integer m, const double x[], const double y[], const double f[], Integer nw, Integer nq, Integer iq[], double rq[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e01shc(Integer m, const double x[], const double y[], const double f[], const Integer iq[], const double rq[], Integer n, const double u[], const double v[], double q[], double qx[], double qy[], NagError *fail);
 

extern NAG_DLL_EXPIMP void NAG_CALL e01sjc(Integer m, const double x[], const double y[], const double f[], Integer triang[], double grads[], NagError *fail);

extern NAG_DLL_EXPIMP void NAG_CALL e01skc(Integer m, const double x[], const double y[], const double f[], const Integer triang[], const double grads[], double px, double py, double *pf, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e01szc(Nag_Scat_Struct *comm);

  extern NAG_DLL_EXPIMP void NAG_CALL e01tgc(Integer m, const double x[], const double y[], const double z[], const double f[], Integer nw, Integer nq, Integer iq[], double rq[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e01thc(Integer m, const double x[], const double y[], const double z[], const double f[], const Integer iq[], const double rq[], Integer n, const double u[], const double v[], const double w[], double q[], double qx[], double qy[], double qz[], NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nage01aux.h>
 #endif
 
  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGE01 */
