/* <nagf01.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library f01 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2149 (Feb 1998).
 * Mark 6 revised. IER-3032 (July 2000).
 */
#ifndef NAGF01
#define NAGF01
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL f01bnc(Integer n, complex a[], Integer tda, double p[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01ecc(Nag_OrderType order, Integer n, double a[], Integer pda, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01edc(Nag_OrderType order, Nag_UploType uplo, Integer n, double a[], Integer lda, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01mcc(Integer n, double *a, Integer lal, Integer *row, double *al, 
                                             double *d, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01qcc(Integer m, Integer n, double *a, Integer tda, double *zeta,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01qdc(MatrixTranspose trans, Nag_WhereElements wheret,
                                             Integer m, Integer n, double *a, Integer tda, double *zeta,
                                             Integer ncolb, double *b, Integer tdb, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01qec(Nag_WhereElements wheret, Integer m, Integer n, Integer ncolq,
                                             double *a, Integer tda, double *zeta, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01rcc(Integer m, Integer n, complex *a, Integer tda, complex *theta,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01rdc(MatrixTranspose trans, Nag_WhereElements wheret, Integer m, Integer n,
                                             complex *a, Integer tda, complex *theta, Integer ncolb, 
                                             complex *b, Integer tdb, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f01rec(Nag_WhereElements wheret, Integer m, Integer n, Integer ncolq, 
                                             complex *a, Integer tda, complex *theta, NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagf01aux.h>
 #endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGF01 */
