/* <nagf02.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library f02 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2150 (Feb 1998).
 * Mark 6 revised. IER-3033 (July 2000).
 */
#ifndef NAGF02
#define NAGF02
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL f02aac(Integer n, double *a, Integer tda, double *r, 
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02abc(Integer n, double *a, Integer tda, double *r, double *v, 
                                             Integer tdv, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02adc(Integer n, double *a, Integer tda, double *b, Integer tdb, 
                                             double *r, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02aec(Integer n, double *a, Integer tda, double *b, Integer tdb,
                                             double *r, double *v, Integer tdv, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02afc(Integer n, double *a, Integer tda, complex *r,
                                             Integer *iter, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02agc(Integer n, double a[],  Integer tda, complex r[],
                                             complex v[],  Integer tdv, Integer iter[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02awc(Integer n, complex a[], Integer tda, double r[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02axc(Integer n, complex a[], Integer tda, double r[],
                                             complex v[], Integer tdv, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02bjc(Integer n, double a[], Integer tda, double b[],
                                             Integer tdb, double tol, complex alfa[],
                                             double beta[], Nag_Boolean wantv,
                                             double v[], Integer tdv, Integer iter[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02ecc(Nag_Select_Eigenvalues crit, Integer n, double a[], Integer lda,
                                             double wl, double wu, Integer mest, Integer *m,
                                             complex w[], complex v[], Integer tdv, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02gcc(Nag_Select_Eigenvalues crit, Integer n, complex a[], Integer lda,
                                             double wl, double wu, Integer mest, Integer *m,
                                             complex w[], complex v[], Integer ldv, NagError *fail);









  extern NAG_DLL_EXPIMP void NAG_CALL f02wec(Integer m, Integer n, double *a, Integer tda, Integer ncolb,
                                             double *b, Integer tdb, Nag_Boolean wantq, double *q, Integer tdq, double *sv,
                                             Nag_Boolean wantp, double *pt, Integer tdpt, Integer *iter, double *e,
                                             Integer *failinfo, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02wgc(Nag_OrderType order, Integer m, Integer n, Integer k, Integer ncv,
                                             NAG_F02WGC_AV av, Integer *nconv, double sigma[], double u[], 
                                             Integer pdu, double v[], Integer pdv, double resid[], Nag_Comm *comm, 
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL f02xec(Integer m, Integer n, complex *a, Integer tda, Integer ncolb,
                                             complex *b, Integer tdb, Nag_Boolean wantq, complex *q, Integer tdq,
                                             double *sv, Nag_Boolean wantp, complex *ph, Integer tdph, Integer *iter,
                                             double *e, Integer *failinfo, NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagf02aux.h>
 #endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGF02 */
