/* <nagg02.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library g02 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2156 (Feb 1998).
 * Mark 6 revised. IER-3041 (July 2000).
 */
#ifndef NAGG02
#define NAGG02
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* Message codes and extern of message list */
//the following include used <name.h>, changed to "name.h"	/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#include "nag_g02mesg.h"
  /* begin proto */
 
 extern NAG_DLL_EXPIMP void NAG_CALL g02aac(Nag_OrderType order, double g[], Integer pdg,
					    Integer n, double errtol, Integer maxits, Integer maxit,
					    double x[], Integer pdx, Integer *iter, Integer *feval, 
					    double *nrmgrd, NagError *fail); 


  extern NAG_DLL_EXPIMP void NAG_CALL g02brc(Integer n, Integer m, double x[], Integer tdx, 
                                             Integer svar[], Integer sobs[], double corr[], 
                                             Integer tdc, NagError *fail);

  extern   NAG_DLL_EXPIMP void NAG_CALL g02btc(Nag_SumSquare mean, Integer m, double wt, const double x[], Integer incx, double *sw, double xbar[], double c[], NagError *fail);
 


  extern  NAG_DLL_EXPIMP void NAG_CALL g02buc(Nag_OrderType order, Nag_SumSquare mean, Integer n, Integer m, const double x[], Integer pdx, const double wt[], double *sw, double wmean[], double c[], NagError *fail);
 


extern  NAG_DLL_EXPIMP void NAG_CALL g02bwc(Integer m, double r[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02bxc(Integer n, Integer m, double x[], 
                                             Integer tdx, Integer sx[], double wt[], double *sw, 
                                             double wmean[], double std[], double r[], Integer tdr,
                                             double v[], Integer tdv, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02bxf_f(const char *weight, Integer n, Integer m, const double x[],
                       Integer ldx, const double wt[], double xbar[], double std[],
                       double v[], Integer ldv, double r[], Integer *ifail,
                       Integer weight_len);

  extern NAG_DLL_EXPIMP void NAG_CALL g02byc(Integer m, Integer ny, Integer nx, const Integer isz[],
                     const double r[], Integer ldr, double p[], Integer ldp,
                     NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02cac(Nag_SumSquare mean, Integer n, 
                                             double x[], double y[], double wt[], double *a, double *b, 
                                             double *a_serr, double *b_serr, double *rsq, double *rss,
                                             double *df, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02caf_f(Integer n, const double x[], const double y[], double result[],
                       Integer *ifail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02cbc(Nag_SumSquare mean, Integer n, double x[], double y[],
                                             double wt[], double clm, double clp, double yhat[],
                                             double yml[], double ymu[], double yl[], double yu[],
                                             double h[], double res[], double *rms, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dac(Nag_IncludeMean mean,Integer n,double x[], Integer tdx,Integer m,
                                             Integer sx[], Integer ip, double y[], double wt[], double *rss,
                                             double *df, double b[], double se[], double cov[], double res[],
                                             double h[], double q[], Integer tdq, Nag_Boolean *svd, Integer *rank,
                                             double p[], double tol, double com_ar[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02daf_f(const char *mean, const char *weight, Integer n, const double x[],
                       Integer ldx, Integer m, const Integer isx[], Integer ip,
                       const double y[], const double wt[], double *rss, Integer *idf,
                       double b[], double se[], double cov[], double res[],
                       double h[], double q[], Integer ldq, Nag_Boolean *svd,
                       Integer *irank, double p[], double tol, double wk[],
                       Integer *ifail, Integer mean_len, Integer weight_len);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dcc(Nag_UpdateObserv update, Nag_IncludeMean mean, Integer m,
                                             Integer sx[], double q[], Integer tdq, Integer ip,
                                             double x[],  Integer nr, Integer tdx, Integer  ix,
                                             double y, double *wt, double *rss, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02ddc(Integer n,Integer ip, double q[], Integer tdq, double *rss,
                                             double *df, double b[], double se[], double cov[], Nag_Boolean *svd,
                                             Integer *rank,double p[], double tol, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dec(Integer n, Integer ip, double q[], Integer tdq, double p[],
                                             double wt[], double x[], double *rss, double tol, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dfc(Integer ip, double q[], Integer tdq, Integer indx, double *rss,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dgc(Integer n,double wt[], double *rss, Integer ip, Integer rank,
                                             double cov[], double q[], Integer tdq, Nag_Boolean svd, double p[],
                                             double y[], double b[], double se[], double res[],
                                             double com_ar[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dgf_f(const char *weight, Integer n, const double wt[], double *rss,
                       Integer ip, Integer irank, double cov[], double q[],
                       Integer ldq, Nag_Boolean svd, const double p[], const double y[],
                       double b[], double se[], double res[], double wk[],
                       Integer *ifail, Integer weight_len);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dkc(Integer ip, Integer iconst, double p[], double c[],
                                             Integer tdc, double b[], double rss, double df,
                                             double se[], double cov[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02dnc(Integer ip, Integer rank, double b[], double cov[],
                                             double p[], double f[], Nag_Boolean *est, double *stat,
                                             double *sestat, double *t, double tol, NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL g02eac(Nag_OrderType order, Nag_IncludeMean mean, Integer n, Integer m, const double x[], Integer pdx, char * var_names[], const Integer sx[], const double y[], const double wt[], Integer *nmod, char * model[], double rss[], Integer nterms[], Integer mrank[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02ecc(Nag_IncludeMean mean, Integer n, double sigsq, double tss, Integer nmod, const Integer nterms[], const double rss[], double rsq[], double cp[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02eec(Nag_OrderType order, Integer *istep, Nag_IncludeMean mean, Integer n, Integer m, const double x[], Integer pdx, char * var_names[], const Integer sx[], Integer maxip, const double y[], const double wt[], double fin, Nag_Boolean *addvar, char * newvar[], double *chrss, double *f, char * model[], Integer *nterm, double *rss, Integer *idf, Integer *ifr, char * free_vars[], double exss[], double q[], Integer pdq, double p[], NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL g02efc(Integer m, Integer n, const double wmean[], const double c[], double sw, Integer isx[],
					     double fin, double fout, double tau, double b[], double se[], double *rsq, double *rms,
					     Integer *df, NAG_G02EFC_MONFUN, Nag_Comm *comm, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02efh(Nag_FullStepwise flag, Integer var, double val,  Nag_Comm *comm);

  extern NAG_DLL_EXPIMP void NAG_CALL g02ewc(Nag_FullStepwise flag, Integer var, double val,  Nag_Comm *comm);


  extern NAG_DLL_EXPIMP void NAG_CALL g02fac(Integer n, Integer ip, Integer nres, double res[], double h[],
                                             double rms, double sres[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02fcc(Integer n, Integer p, const double res[], double *d, double *pdl, double *pdu, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02gac(Nag_Link link, Nag_IncludeMean mean, Integer n, double x[],
                                             Integer tdx, Integer m, Integer sx[], Integer ip, double y[],
                                             double wt[], double offset[], double *scale, double ex_power,
                                             double *rss, double *df, double b[], Integer *rank, double se[],
                                             double cov[], double v[], Integer tdv, double tol,
                                             Integer max_iter, Integer print_iter, const char *outfile, double eps,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gbc(Nag_Link link, Nag_IncludeMean mean, Integer n, double x[],
                                             Integer tdx, Integer m, Integer sx[], Integer ip, double y[],
                                             double binom_t[], double wt[], double offset[], double *dev,
                                             double *df, double b[], Integer *rank, double se[],
                                             double cov[], double v[], Integer tdv, double tol,
                                             Integer max_iter, Integer print_iter, const char *outfile,
                                             double eps, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gcc(Nag_Link link, Nag_IncludeMean mean, Integer n, double x[],
                                             Integer tdx, Integer m, Integer sx[], Integer ip, double y[], 
                                             double wt[], double offset[], double ex_power, double *dev,
                                             double *df, double b[], Integer *rank, double se[], double cov[], 
                                             double v[], Integer tdv, double tol, Integer max_iter, 
                                             Integer print_iter, const char *outfile, double eps, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gcf_f(const char *link, const char *mean, const char *offset, const char *weight,
                       Integer n, const double x[], Integer ldx, Integer m,
                       const Integer isx[], Integer ip, const double y[], const double wt[],
                       double a, double *dev, Integer *idf, double b[],
                       Integer *irank, double se[], double cov[], double v[],
                       Integer ldv, double tol, Integer maxit, Integer iprint,
                       double eps, double wk[], Integer *ifail, Integer link_len,
                       Integer mean_len, Integer offset_len, Integer weight_len);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gdc(Nag_Link link, Nag_IncludeMean mean, Integer n, double x[],
                                             Integer tdx, Integer m, Integer sx[], Integer ip, double y[],
                                             double wt[], double offset[], double *scale, double ex_power,
                                             double *dev, double *df, double b[], Integer *rank, double se[],
                                             double cov[], double v[], Integer tdv, double tol,
                                             Integer max_iter, Integer print_iter, const char *outfile, double eps,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gkc(Integer ip, Integer nclin, double v[], Integer tdv, double c[],
                                             Integer tdc, double b[], double scale, double se[], double cov[],
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gnc(Integer ip, Integer rank, double b[], double cov[], double v[],
                                             Integer tdv, double f[], Nag_Boolean *est, double *stat, 
                                             double *sestat, double *z, double tol, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02gpc(Nag_Distributions errfn, Nag_Link link, Nag_IncludeMean mean, Integer n,
                                             const double x[], Integer pdx, Integer m, const Integer sx[], Integer ip,
                                             const double binom_t[], const double offset[], const double wt[], 
                                             double scalar, double ex_power, const double b[], const double cov[],
                                             Nag_Boolean vfobs, double eta[], double seeta[], double pred[],
                                             double sepred[], NagError *fail); 

  extern NAG_DLL_EXPIMP void NAG_CALL g02hac(Nag_RegType regtype, Nag_PsiFun psifun, 
                                             Nag_SigmaEst sigma_est, Nag_CovMatrixEst covmat_est, Integer n, 
                                             Integer m, double x[], Integer tdx, double y[], 
                                             double cpsi, double hpsi[], double cucv, double dchi, 
                                             double theta[], double *sigma, double c[], Integer tdc, 
                                             double rs[], double wt[], double tol, Integer max_iter,
                                             Integer print_iter, const char *outfile, double info[], NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL g02hbc(Nag_OrderType order,
                                             NAG_G02HBC_UCV, Integer n,
                                             Integer m, const double x[],
                                             Integer ix, double a[], double z[],
                                             double bl, double bd, double tol,
                                             Integer maxit, Integer nitmon,
                                             const char *outfile, Integer *nit,
                                             Nag_Comm *comm, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02hdc(Nag_OrderType order,
                                             NAG_G02HDC_CHI, NAG_G02HDC_PSI,
                                             double psip0, double beta,
                                             Nag_RegType regtype,
                                             Nag_SigmaEst sigma_est, Integer n,
                                             Integer m, double x[], Integer ix,
                                             double y[], double wgt[],
                                             double theta[], Integer *k,
                                             double *sigma, double rs[],
                                             double tol, double eps,
                                             Integer maxit, Integer nitmon,
                                             const char *outfile, Integer *nit,
                                             Nag_Comm *comm, NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL g02hfc(Nag_OrderType order,
                                             NAG_G02HFC_PSI, NAG_G02HFC_PSP,
                                             Nag_RegType regtype,
                                             Nag_CovMatrixEst covmat_est,
                                             double sigma, Integer n, Integer m,
                                             const double x[], Integer ix,
                                             const double rs[],
                                             const double wgt[], double cov[],
                                             Integer ic, double comm_arr[],
                                             Nag_Comm *comm, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02hkc(Integer n, Integer m, double x[], Integer tdx, 
                                             double eps, double cov[], double theta[], Integer max_iter,
                                             Integer print_iter, const char *outfile, double tol, Integer *iter, 
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02hlc(Nag_OrderType order, NAG_G02HLC_UCV, Integer indm, Integer n,
                                             Integer m, const double x[], Integer pdx, double cov[], double a[],
                                             double wt[], double theta[], double bl, double bd, Integer maxit,
                                             Integer nitmon, const char * outfile, double tol, Integer *nit,
                                             Nag_Comm *comm, NagError *fail);


extern NAG_DLL_EXPIMP void NAG_CALL g02hmc(Nag_OrderType order, NAG_G02HMC_UCV, Integer indm, Integer n,
                                           Integer m, const double x[], Integer pdx, double cov[], double a[],
                                           double wt[], double theta[], double bl, double bd, Integer maxit,
                                           Integer nitmon, const char * outfile, double tol, Integer *nit,
                                           Nag_Comm *comm, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02jac(Integer n, Integer ncol, const double dat[], Integer tddat,
                                             const Integer levels[], Integer yvid, Integer cwid, Integer nfv,
                                             const Integer fvid[], Integer fint, Integer nrv,
                                             const Integer rvid[], Integer nvpr, const Integer vpr[],
                                             Integer rint, Integer svid, double gamma[], Integer *nff,
                                             Integer *nrf, Integer *df, double *reml, Integer lb, double b[],
                                             double se[], Integer maxit, double tol, Integer *warn, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL g02jbc(Integer n, Integer ncol, const double dat[], Integer tddat,
                                             const Integer levels[], Integer yvid, Integer cwid, Integer nfv,
                                             const Integer fvid[], Integer fint, Integer nrv, const Integer rvid[],
                                             Integer nvpr, const Integer vpr[], Integer rint, Integer svid,
                                             double gamma[], Integer *nff, Integer *nrf, Integer *df, double *ml,
                                             Integer lb, double b[], double se[], Integer maxit, double tol,
                                             Integer *warn, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02jcc(Nag_OrderType order, Integer n, Integer ncol, double dat[], Integer pddat, 
                                             Integer levels[], double y[], double *wt, Integer fixed[], Integer lfixed, 
                                             Integer nrand, Integer rand[], Integer pdrand, Integer *nff, Integer *nlsv,
                                             Integer *nrf, double rcomm[], Integer lrcomm, Integer icomm[], Integer licomm, 
                                             NagError *fail);
  
  extern NAG_DLL_EXPIMP void NAG_CALL g02jdc(Integer livpr, Integer ivpr[], Integer nvpr, double gamma[], Integer *effn, 
                                             Integer *rnkx, Integer *ncov, double *like, Integer lb, Integer id[], Integer pdid, 
                                             double b[], double se[], double czz[], Integer pdczz, double cxx[], Integer pdcxx, 
                                             double cxz[], Integer pdcxz, double rcomm[], Integer icomm[], Integer iopt[], 
                                             Integer liopt, double ropt[], Integer lropt, NagError *fail);
  
  extern NAG_DLL_EXPIMP void NAG_CALL g02jec(Integer livpr, Integer ivpr[], Integer nvpr, double gamma[], Integer *effn, 
                                             Integer *rnkx, Integer *ncov, double *like, Integer lb, Integer id[], Integer pdid, 
                                             double b[], double se[], double czz[], Integer pdczz, double cxx[], Integer pdcxx, 
                                             double cxz[], Integer pdcxz, double rcomm[], Integer icomm[], Integer iopt[], 
                                             Integer liopt, double ropt[], Integer lropt, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g02kac(Nag_OrderType order, Integer n, Integer m, const double x[], Integer pdx, const Integer isx[], Integer ip, double tau, const double y[], double *h, Nag_PredictError opt, Integer *niter, double tol, double *nep, Nag_EstimatesOption orig, double b[], double vif[], double res[], double *rss, Integer *df, Nag_OptionLOO optloo, double perr[], NagError *fail); 


extern NAG_DLL_EXPIMP void NAG_CALL g02kbc(Nag_OrderType order, Integer n, Integer m, const double x[], Integer pdx, const Integer isx[], Integer ip, const double y[], Integer lh, const double h[], double nep[], Nag_ParaOption wantb, double b[], Integer pdb, Nag_VIFOption wantvf, double vf[], Integer pdvf, Integer lpec, const Nag_PredictError pec[], double pe[], Integer pdpe, NagError *fail); 


extern NAG_DLL_EXPIMP void NAG_CALL g02lac(Nag_OrderType order, Integer n, Integer mx, const double x[], Integer pdx, const Integer isx[], Integer ip, Integer my, const double y[], Integer pdy, double xbar[], double ybar[], Nag_ScalePredictor iscale, double xstd[], double ystd[], Integer maxfac, double xres[], Integer pdxres, double yres[], Integer pdyres, double w[], Integer pdw, double p[], Integer pdp, double t[], Integer pdt, double c[], Integer pdc, double u[], Integer pdu, double xcv[], double ycv[], Integer pdycv, NagError *fail); 


extern NAG_DLL_EXPIMP void NAG_CALL g02lbc(Nag_OrderType order, Integer n, Integer mx, const double x[], Integer pdx, const Integer isx[], Integer ip, Integer my, const double y[], Integer pdy, double xbar[], double ybar[], Nag_ScalePredictor iscale, double xstd[], double ystd[], Integer maxfac, Integer maxit, double tau, double xres[], Integer pdxres, double yres[], Integer pdyres, double w[], Integer pdw, double p[], Integer pdp, double t[], Integer pdt, double c[], Integer pdc, double u[], Integer pdu, double xcv[], double ycv[], Integer pdycv, NagError *fail); 


extern NAG_DLL_EXPIMP void NAG_CALL g02lcc(Nag_OrderType order, Integer ip, Integer my, Integer maxfac, Integer nfact, const double p[], Integer pdp, const double c[], Integer pdc, const double w[], Integer pdw, double rcond, double b[], Integer pdb, Nag_EstimatesOption orig, const double xbar[], const double ybar[], Nag_ScalePredictor iscale, const double xstd[], const double ystd[], double ob[], Integer pdob, Integer vipopt, const double ycv[], Integer pdycv, double vip[], Integer pdvip, NagError *fail); 

extern NAG_DLL_EXPIMP void NAG_CALL g02ldc(Nag_OrderType order, Integer ip, Integer my, Nag_EstimatesOption orig, const double xbar[], const double ybar[], Nag_ScalePredictor iscale, const double xstd[], const double ystd[], const double b[], Integer pdb, Integer n, Integer mz, const Integer isz[], const double z[], Integer pdz, double yhat[], Integer pdyhat, NagError *fail); 


#ifdef NAGLIBANDSTINCLUDE
#include <nagg02aux.h>
 #endif
 

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGG02 */
