/* <nagg03.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library g03 Chapter
 *
 * Mark 5, 1997.
 * Mark 6 revised. IER-3042 (July 2000).
 */
#ifndef NAGG03
#define NAGG03
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
//following two includes used <name.h>, changed to "name.h"	/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#include "nag_stddef.h"
#include "nag_g03mesg.h"
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL g03aac(Nag_PrinCompMat pcmatrix, Nag_PrinCompScores scores, Integer n,
                                             Integer m, double x[],  Integer tdx, Integer isx[],  double s[],
                                             double *wtptr,  Integer nvar,  double e[],  Integer tde,
                                             double p[],  Integer tdp,  double v[],  Integer tdv,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03acc(Nag_Weightstype weights, Integer n, Integer m,  double x[],
                                             Integer tdx, Integer isx[], Integer nx, Integer ing[],
                                             Integer ng,  double *wtptr,  Integer nig[],
                                             double cvm[],  Integer tdcvm,  double e[],
                                             Integer tde, Integer *ncv,  double cvx[],  Integer tdcvx,
                                             double tol,  Integer *irankx, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03adc(Integer n, Integer m,  double z[],
                                             Integer tdz, Integer isz[], Integer nx, Integer ny,
                                             double *wtptr, double e[],  Integer tde, Integer *ncv,
                                             double cvx[],  Integer tdcvx,
                                             double cvy[],  Integer tdcvy,  double tol, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03bac(Nag_RotationLoading stand, double g,  Integer nvar, Integer k,
                                             double fl[],  Integer tdf,  double flr[],
                                             double r[],  Integer tdr,  double acc,  Integer maxit,
                                             Integer *iter,  NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03bcc(Nag_TransNorm stand, Nag_RotationScale pscale, Integer n,
                                             Integer m, double x[],  Integer tdx,  double y[],
                                             Integer tdy, double yhat[], double r[],  Integer tdr,
                                             double *alpha, double *rss, double res[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03bdc(Nag_RotationLoading stand, Integer n, Integer m,
                                             const double x[], Integer pdx, const double ro[], Integer pdro,
                                             double power, double fp[], Integer pdfp, double r[],
                                             Integer pdr, double phi[], Integer pdphi, double fs[],
                                             Integer pdfs, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03cac(Nag_FacMat Nmatrix, Integer n, Integer m,
                                             double x[],  Integer tdx, Integer nvar, Integer isx[],
                                             Integer nfac,  double *wtptr, double e[], double stat[],
                                             double com[], double psi[], double res[],
                                             double fl[],  Integer tdfl, Nag_E04_Opt *options, double eps,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03ccc(Nag_FacScoreMethod method, Nag_FacRotation rotate,  Integer nvar,
                                             Integer nfac,
                                             double fl[],  Integer tdfl,  double psi[],
                                             double e[], double r[],  Integer tdr,  double fs[],
                                             Integer tdfs, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03dac(Integer n, Integer m,  double x[],
                                             Integer tdx, Integer isx[], Integer nvar, Integer ing[],
                                             Integer ng,  double *wtptr,  Integer nig[],
                                             double gmean[],  Integer tdg,  double det[],
                                             double gc[], double *stat, double *df, double *sig,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03dbc(Nag_GroupCovars equal, Nag_MahalDist mode,  Integer nvar, Integer ng,
                                             double gmean[],  Integer tdg,  double gc[],
                                             Integer nobs, Integer m, Integer isx[],  double x[],
                                             Integer tdx,  double d[],  Integer tdd,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03dcc(Nag_DiscrimMethod type, Nag_GroupCovars equal, Nag_PriorProbability priors, Integer nvar,
                                             Integer ng, Integer nig[],  double gmean[],  Integer tdg,
                                             double gc[], double det[],  Integer nobs, Integer m,
                                             Integer isx[],  double x[],  Integer tdx,
                                             double prior[], double p[],  Integer tdp, Integer iag[],
                                             Nag_Boolean atiq,  double ati[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03eac(Nag_MatUpdate update, Nag_DistanceType dist, Nag_VarScaleType scale,
                                             Integer n, Integer m, double x[],  Integer tdx, Integer isx[],
                                             double s[], double d[],  NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03ecc(Nag_ClusterMethod method, Integer n,  double d[],  Integer ilc[],
                                             Integer iuc[],  double cd[],  Integer iord[],
                                             double dord[],  NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03efc(Integer n, Integer m,  double x[],
                                             Integer tdx, Integer isx[], Integer nvar, Integer k,
                                             double cmeans[],  Integer tdc,  double *wtptr,
                                             Integer inc[], Integer nic[],  double css[],
                                             double csw[],  Integer maxit,  NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03ehc(Nag_DendOrient orient,  Integer n,  double dord[], double dmin_,
                                             double dstep,  Integer nsym,  char ***c, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03ejc(Integer n,  double cd[],  Integer iord[],
                                             double dord[],  Integer *k,  double *dlevel,
                                             Integer ic[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03fac(Nag_Eigenvalues roots,  Integer n,  double d[],  Integer ndim,
                                             double x[],  Integer tdx,  double eval[],
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03fcc(Nag_ScaleCriterion type,  Integer n, Integer ndim,  double d[],
                                             double x[],  Integer tdx,  double *stress,
                                             double dfit[],  
                                             Nag_E04_Opt *options, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03xzc(char ***c);

  extern NAG_DLL_EXPIMP void NAG_CALL g03zac(Integer n, Integer m,  double x[],  Integer tdx,
                                             Integer nvar, Integer isx[],  double s[], double e[],
                                             double z[],  Integer tdz, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g03zaf_f(Integer n, Integer m, const double x[], Integer ldx,
                       Integer nvar, const Integer isx[], const double s[], const double e[],
                       double z[], Integer ldz, Integer *ifail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagg03aux.h>
 #endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGG03 */
