/* <nagg04.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library g04 Chapter
 *
 * Mark 5, 1997.
 * Mark 6 revised. IER-3043 (July 2000).
 */
#ifndef NAGG04
#define NAGG04
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL g04bbc(Integer n, double y[], Nag_Blocks blocks, Integer iblock, Integer nt,
                                             Integer it[], double *gmean, double bmean[],
                                             double tmean[], double table[], double c[], Integer tdc,
                                             Integer irep[], double r[], double ef[], double tol,
                                             Integer irdf, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g04bcc(Integer nrep, Integer nrow, Integer ncol, const double y[],
                     Integer nt, const Integer it[], double * gmean,
                     double tmean[], double table[], double c[], Integer tdc,
                     Integer irep[], double rpmean[], double rmean[],
                     double cmean[], double r[], double ef[], double tol,
                     Integer irdf, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g04cac(Integer n, double y[], Integer nfac, Integer lfac[],
                                             Integer nblock, Integer inter, Integer irdf, Integer *mterm,
                                             double **table, double **tmean,
                                             Integer *maxt, double **e, Integer **imean,
                                             double **semean, double **bmean, double r[],
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g04czc(double **table, double **tmean, double **e,
                                             Integer **imean, double **semean, double **bmean);

  extern NAG_DLL_EXPIMP void NAG_CALL g04dbc(Nag_IntervalType type, Integer nt, const double tmean[], double rdf,
                     const double c[], Integer ldc, double clevel, double cil[],
                     double ciu[], Integer isig[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g04eac(Nag_DummyType type, Integer n, Integer levels, const Integer ifact[],
                     double x[], Integer tdx, const double v[], double rep[],
                     NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagg04aux.h>
 #endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGG04 */
