/* <nagg10.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library g10 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2159 (Feb 1998).
 * Mark 6 revised. IER-3046 (July 2000).
 */
#ifndef NAGG10
#define NAGG10
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
//the following includes used <name.h>, changed to "name.h"	/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#include "nag_stddef.h"
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL g10abc(Nag_SmoothFitType mode, Integer n, const double x[],
                     const double y[], const double wt[], double rho, double yhat[],
                     double c[], double *rss, double *df,
                     double res[], double h[], double wk[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g10acc(Nag_SmoothParamMethods method, Integer n, const double x[],
                     const double y[], const double wt[], double yhat[], double c[],
                     double *rss, double *rdf, double res[],
                     double h[], double *crit, double *rho, double u,
                     double tol, Integer maxcal, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g10bac(Integer n, const double x[], double window, double slo,
                     double shi, Integer ns, double smooth[], double t[],
                     NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g10cac(Nag_Smooth_Type smoother, Integer n, double y[], double smooth[],
                                             double rough[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g10zac(Integer n, const double x[], const double y[],
                     const double wt[], Integer *nord, double xord[], double yord[],
                     double wwt[], double *rss, NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagg10aux.h>
 #endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGG10 */
