/* <nagg12.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library g12 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2161 (Feb 1998).
 * Mark 6 revised. IER-3048 (July 2000).
 */
#ifndef NAGG12
#define NAGG12
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* Message codes and extern of message list */
//the following includes used <name.h>, changed to "name.h"	/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#include "nag_g12mesg.h"
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL g12aac(Integer n,  double t[],  Integer ic[],  Integer ifreq[],
                                             Integer *nd,  double tp[], double p[], double psig[],
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL g12aaf_f(Integer n, const double t[], const Integer ic[], const char *freq,
                       const Integer ifreq[], Integer *nd, double tp[], double p[],
                       double psig[], Integer iwk[], Integer *ifail, Integer freq_len);

  extern NAG_DLL_EXPIMP void NAG_CALL g12bac(Integer n, Integer m, Integer ns,
                     const double z[], Integer ldz, const Integer isz[], Integer ip,
                     const double t[], const Integer ic[], const double omega[], const Integer isi[],
                     double *dev, double b[], double se[], double sc[],
                     double cov[], double res[], Integer *nd, double tp[],
                     double sur[], Integer tdsur, Integer ndmax,  double tol, Integer maxit,
                     Integer iprint, const char *outfile, NagError *fail);


extern  NAG_DLL_EXPIMP void NAG_CALL g12zac(Nag_OrderType order, Integer n, Integer m, Integer ns, const double z[], Integer pdz, const Integer isz[], Integer ip, const double t[], const Integer ic[], const Integer isi[], Integer *num, Integer ixs[], Integer *nxs, double x[], Integer mxn, Integer id[], Integer *nd, double tp[], Integer irs[], NagError *fail);


#ifdef NAGLIBANDSTINCLUDE
#include <nagg12aux.h>
 #endif
 


  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGG12 */
