/*------------------------------------------------------------------------------*
 * File Name: OC_NAG.h															*
 * Creation: CPY 5/15/2001														*
 * Purpose: Origin C Header for NAG functions									*
 * Copyright (c) OriginLab Corp.	2001										*
 * All Rights Reserved															*
 * 																				*
 * Modification Log:															*
 * GJL 1/29/04 Exclude unneeded NAG header files in Origin 8.0					*
 * Zech 08/23/2011 ORG-3583-P1 REPLACE_ALL_NAG8_TEXT_WITH_NAG					*
 *------------------------------------------------------------------------------*/

/// Zech 08/23/2011 ORG-3583-P1 REPLACE_ALL_NAG8_TEXT_WITH_NAG
/*
#ifndef _O_NAG_H
#define _O_NAG_H

//#importdll "ONAG" // NAG DLL prepared by OriginLab
#pragma dll(ONAG)

// Eventually remove all NAG header files but for now just include header files used
// internally by Origin.
#include <NAG\nag_types.h> // Enums and TypeDefs
#include <NAG\OCN_e01.h>   // Interpolation
#include <NAG\OCN_g01.h>   // Basic Statistics
#include <NAG\OCN_g02.h>   // Regression Analysis
#include <NAG\OCN_g04.h>   // ANOVA
#include <NAG\OCN_g12.h>   // Survival Analysis
#include <NAG\OCN_s.h>     // Special Functions in LT_math.c

#endif //!_O_NAG_H
*/

#pragma PCH	
#include <origin.h>

#ifndef _O_NAG_H
#define _O_NAG_H

#pragma message("NAG is included")

#include	<NAG\nag.h>
#include	<NAG\nags.h>
#include    <NAG\nag_stdlib.h>


#include	<NAG\nagg01.h>
#include	<NAG\nagg02.h>
#include	<NAG\nagg04.h>
#include	<NAG\nagg07.h> 
#include	<NAG\nagg08.h>
#include	<NAG\nagg12.h>

#include	<NAG\nage01.h>
#include	<NAG\nage02.h>

#include	<NAG\naga00.h>
#include	<NAG\naga02.h>

#include	<NAG\nagc02.h>
#include	<NAG\nagc05.h>
#include	<NAG\nagc06.h>

#include	<NAG\nagd01.h>
#include	<NAG\nagd02.h>
#include	<NAG\nagd03.h>
#include	<NAG\nagd06.h>

#include	<NAG\nage04.h>

#include	<NAG\nagf01.h>
#include	<NAG\nagf02.h>
#include	<NAG\nagf03.h>
#include	<NAG\nagf04.h>
#include	<NAG\nagf06.h>
#include	<NAG\nagf07.h>
#include	<NAG\nagf08.h>
#include	<NAG\nagf11.h>
#include	<NAG\nagf16.h>

#include	<NAG\nagg03.h>

#include	<NAG\nagg10.h>
#include	<NAG\nagg11.h>
#include	<NAG\nagg13.h>

#include	<NAG\nagh02.h> 
#include	<NAG\nagh03.h>

#include	<NAG\nagm01.h> 

#include	<NAG\nagp01.h>

#include	<NAG\nagx01.h>
#include	<NAG\nagx02.h>
#include	<NAG\nagx03.h>
#include	<NAG\nagx04.h>

#endif //!_O_NAG_H

/// END REPLACE_ALL_NAG8_TEXT_WITH_NAG